%Generate transportation demands

%SET PARAMETERS (EXPECTED DEMAND GROWTH AND DEMAND SHARE BETWEEN PORTS)
DemandGrowth=1.1;
Share=[0.80, 0.05, 0.15];
MarketShare=1;
nPeriods=4;
nVisits=[4 2 3];

%% SORT DATA FROM EXCEL SHEET: 
Data=xlsread('20173171116118512200947Havnest5.xlsx');

Trondheim=Data(1:12,:);
Verdal=Data(13:24,:);

Total=Trondheim+Verdal;
lolo_Total=Total(1:6,:);
roro_Total=Total(7:12,:); %0 roro.

unloaded_AllDir=sum(lolo_Total(1:3,:));
loaded_AllDir=sum(lolo_Total(4:6,:));

c=1;
for i=1:2:length(Total)
    Filled_unloaded_AllDir(c)=unloaded_AllDir(i);
    Filled_loaded_AllDir(c)=loaded_AllDir(i);
    c=c+1;
end

c=1;
for i=2:2:length(Total)
    Empty_unloaded_AllDir(c)=unloaded_AllDir(i);
    Empty_loaded_AllDir(c)=loaded_AllDir(i);
    c=c+1;
end

Total_unloaded_AllDir=Filled_unloaded_AllDir+Empty_unloaded_AllDir;
Total_loaded_AllDir=Filled_loaded_AllDir+Empty_loaded_AllDir;

TotalContainerMoves_each_way=(Total_unloaded_AllDir+Total_loaded_AllDir)/2;


%% Generate random realizations of container demands based on uniform distribution, +-10% from mean:

%Set random number seed. (For reproducability)
rng(1234);
simValues=randi([round(mean(TotalContainerMoves_each_way)*(1-0.2)) round(mean(TotalContainerMoves_each_way)*(1+0.2))],10000,1);

%Plot histogram of simulated demands
figure;
histogram(simValues,'Normalization','pdf');
title('Simulated demands')

PeriodicDemands=simValues*DemandGrowth*MarketShare/(3*4*2); 
%3 months in a quarter, 4 weeks in a month, 2 periods in a week

%% Values used as input in simulation model:
IngoingDemandsOrkanger=round(PeriodicDemands*Share(1)*(nPeriods/nVisits(1)));
IngoingDemandsTrondheim=round(PeriodicDemands*Share(2)*(nPeriods/nVisits(2)));
IngoingDemandsSkogn=round(PeriodicDemands*Share(3)*(nPeriods/nVisits(3)));

%Alternatively for deterministic model run. Overwrite demand vectors. 
%   IngoingDemandsOrkanger(1:end)=round(mean(TotalContainerMoves_each_way)*Share(1)*MarketShare*DemandGrowth/(3*4*2)*nPeriods/nVisits(1));
%   IngoingDemandsTrondheim(1:end)=round(mean(TotalContainerMoves_each_way)*Share(2)*MarketShare*DemandGrowth/(3*4*2)*nPeriods/nVisits(2));
%   IngoingDemandsSkogn(1:end)=round(mean(TotalContainerMoves_each_way)*Share(3)*MarketShare*DemandGrowth/(3*4*2)*nPeriods/nVisits(3));


%% Expected build-up of containers per period
PerPeriodIngoingOrk=round(mean(TotalContainerMoves_each_way)*Share(1)*MarketShare*DemandGrowth/(3*4*2));
PerPeriodIngoingTrh=round(mean(TotalContainerMoves_each_way)*Share(2)*MarketShare*DemandGrowth/(3*4*2));
PerPeriodIngoingSkogn=round(mean(TotalContainerMoves_each_way)*Share(3)*MarketShare*DemandGrowth/(3*4*2));



